A portable, open-source, coherent noise-generating library for C++

Main Page | Modules | Class Hierarchy | Class List | File List | Class Members

# noise::module::Spheres Class Reference
[Generator Modules]

`#include <spheres.h>`

Inheritance diagram for noise::module::Spheres:

List of all members.

## Detailed Description

Noise module that outputs concentric spheres.

This noise module outputs concentric spheres centered on the origin like the concentric rings of an onion.

The first sphere has a radius of 1.0. Each subsequent sphere has a radius that is 1.0 unit larger than the previous sphere.

The output value from this noise module is determined by the distance between the input value and the the nearest spherical surface. The input values that are located on a spherical surface are given the output value 1.0 and the input values that are equidistant from two spherical surfaces are given the output value -1.0.

An application can change the frequency of the concentric spheres. Increasing the frequency reduces the distances between spheres. To specify the frequency, call the SetFrequency() method.

This noise module, modified with some low-frequency, low-power turbulence, is useful for generating agate-like textures.

This noise module does not require any source modules.

## Public Member Functions

| Spheres ()
| Constructor.
double | GetFrequency () const
| Returns the frequency of the concentric spheres.
virtual int | GetSourceModuleCount () const
| Returns the number of source modules required by this noise module.
virtual double | GetValue (double x, double y, double z) const
| Generates an output value given the coordinates of the specified input value.
void | SetFrequency (double frequency)
| Sets the frequenct of the concentric spheres.

## Protected Attributes

double | m_frequency
| Frequency of the concentric spheres.

## Constructor & Destructor Documentation

Spheres::Spheres | ( |  | ) |

| Constructor. The default frequency is set to noise::module::DEFAULT_SPHERES_FREQUENCY.

## Member Function Documentation

double noise::module::Spheres::GetFrequency | ( |  | ) | const`[inline]`

Returns the frequency of the concentric spheres.

Returns:
  The frequency of the concentric spheres.

Increasing the frequency increases the density of the concentric spheres, reducing the distances between them.

virtual int noise::module::Spheres::GetSourceModuleCount | ( |  | ) | const`[inline, virtual]`

Returns the number of source modules required by this noise module.

Returns:
  The number of source modules required by this noise module.

Implements noise::module::Module.

double Spheres::GetValue | ( | double | x,
|  | double | y,
|  | double | z
| ) | const`[virtual]`

Generates an output value given the coordinates of the specified input value.

Parameters:

  | x | The x coordinate of the input value.
  | y | The y coordinate of the input value.
  | z | The z coordinate of the input value.

Returns:
  The output value.

Precondition:
  All source modules required by this noise module have been passed to the SetSourceModule() method.

Before an application can call this method, it must first connect all required source modules via the SetSourceModule() method. If these source modules are not connected to this noise module, this method raises a debug assertion.

To determine the number of source modules required by this noise module, call the GetSourceModuleCount() method.

Implements noise::module::Module.

void noise::module::Spheres::SetFrequency | ( | double | frequency | ) | `[inline]`

Sets the frequenct of the concentric spheres.

Parameters:

  | frequency | The frequency of the concentric spheres.

Increasing the frequency increases the density of the concentric spheres, reducing the distances between them.

The documentation for this class was generated from the following files:

- spheres.h
- spheres.cpp